import cv2.cv2 as cv

def mask():
    face_cascade = cv.CascadeClassifier('haarcascade_frontalface_alt2.xml')#人脸模型
    nose_cascade = cv.CascadeClassifier('haarcascade_mcs_nose.xml')#人鼻子模型
    mask_detector = cv.CascadeClassifier('mask.xml')#口罩模型
    cameraCapture = cv.VideoCapture(0, cv.CAP_DSHOW)#如果是只连接一个摄像头则默认0（包括笔记本电脑自带的摄像头），其余的外接可能需要更换数字
    while True:
        
        ret, frame = cameraCapture.read()
        gray = cv.cvtColor(frame, cv.COLOR_BGR2GRAY)
        faces = face_cascade.detectMultiScale(gray, 1.2, 10)
        masks = mask_detector.detectMultiScale(gray, 1.03, 5)
        noses = nose_cascade.detectMultiScale(gray, 1.2, 10)
        for (x, y, w, h) in faces:#搜索人脸
            cv.rectangle(frame, (x, y), (x + w, y + h), (0, 0, 255), 2)#框出对象
            cv.putText(frame, "no_mask", (x, y), cv.FONT_HERSHEY_SIMPLEX, 1, (0, 0, 255), 2)#加上提示语句

        for (nx, ny, nw, nh) in noses:#搜索人的鼻子
            cv.rectangle(frame, (nx, ny), (nx + nw, ny + nh), (10, 10, 255), 2)#框出对象
            cv.putText(frame, "no_mask", (nx, ny), cv.FONT_HERSHEY_SIMPLEX, 1, (0, 0, 255), 2)#加上提示语句

        for (mx, my, mw, mh) in masks:#搜索戴着口罩的人
            cv.rectangle(frame, (mx, my), (mx + mw, my + mh), (0, 255, 0), 2)#框出对象
            cv.putText(frame, "have_mask", (mx, my), cv.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2)#加上提示语句

        c = cv.waitKey(5)
        if c == 27:#按esc结束程序运行
            break
            
        cv.imshow('camera', frame)

    cameraCapture.release()
    cv.destroyAllWindows()

if __name__=='__main__':#主循环
        mask()